      
	IMPLICIT REAL*8 (A-h,O-Z)
	parameter (n=51)
	parameter (lm=2)
	parameter (lmn = lm*n)
	parameter (rmin = 1.e-5)
	parameter (rmax = 1.d0)

      dimension b(lmn,lmn),F(lmn),v(lmn),v1(lmn),r1(lmn),
     ^X(n),R3(lmn),R2(lmn),TKSI(n),fi(lm,n)
ccc
      h=(rmax-rmin)/(N-1)
c	print *,h

      tau0= .1
	ntau = 3
	ht5 = .1

	gnorm = 1.d0/3.d0 + 1.d0/5.d0

      eps=.00001
      nmax=30

	ev = .9d0
ccc
      do i=1,n

      x(i)=(i-1)*h+rmin
	fi(1,i) = x(i)**1.1
	fi(2,i) = x(i)**2.1

	end do

	print *,x(3),x(4),gnorm
ccc    
      call sysint(n,lm,lmn,x,ev,fi,tau0,ntau,ht5,gnorm,eps,nmax,f,
     ^	v,v1,r1,r2,r3,tksi,b)
ccc
	print *,'ev=',ev

	do i=1,n
	write (1,*) x(i),fi(1,i),fi(2,i)
	end do

	write (1,*) 'ev=',ev

1000  format(3e15.7)
      end

C*
C*******************************************************************
C*
      SUBROUTINE sysint(n,lm,lmn,x,ev,fi,tau0,ntau,ht5,gnorm,eps,nmax,f,
     ^	v,v1,r1,r2,r3,tksi,b)

	IMPLICIT REAL*8 (A-h,O-Z)
	
      dimension b(lmn,lmn),F(lmn),v(lmn),v1(lmn),r1(lmn),
     ^X(n),R3(lmn),R2(lmn),TKSI(n),fi(lm,n),fi2(lm,n),ipm(lmn)
      
      NM1=N-1
	nd5 = nm1/10
	h = x(4)-x(3)
	
      do 559 l=1,lm
      l1n=(l-1)*n
      do 559 i=1,n
      l1ni=l1n+i        
      v(l1ni)=0.d0
      v1(l1ni)=0.d0
 559  continue
CCC
      call norm(n,lm,h,R1,fi,gnorm)

CCC
C-------------------------------- PARAMETERS FOR 'TAU', -----
CCC

      NIT=0
      D0=0.d0
      D1=0.d0
      TP=TAU0
      TAU=TAU0
CCC
C-------------------------------- CALCULATION OF KSI
CCC
      call ksi(n,h,tksi)
C
C-------------------------------- START OF NEWTONIAN ITERATION 
C
  421 CONTINUE
C 
      do 488 l=1,lm
      l1n=(l-1)*n
      do 488 i=1,n
      l1ni=l1n+i
      r3(l1ni)=0.d0
      do 48 k=1,lm
      r3(l1ni)=rrr(l,k,x(i))*fi(k,i)+r3(l1ni)      
  48  continue
 488  continue
C
      CALL CALCF(LM,N,LMN,h,X,F,r1,fi,ev)
C
      DO 1 I=1,LMN
      IF(ABS(F(I)).LT.D1) go to 1
      LMAX=I
      D1=AbS(F(I))
   1  CONTINUE

      print *,'---------------------------------------'
      print *,'-------------- NIT=' ,nit
      print *,'---------------------------------------'
      PRINT *,' ev=',ev,' Dmax=',d1,' LMAX=',LMAX

      print *,'^^^^^^ i, x(i), fi1(i), FI2(I) ^^^^^^'
      do 335 i=1,n,nd5
 335  PRINT 1000,i,x(i),fi(1,i),fI(2,i)

      IF(D1.LE.EPS)GO TO 100
      IF(NIT.GE.NMAX)GO TO 200
CCC
      CALL CALCA(LM,N,LMN,X,b,R1,fi,TKSI,ev)
CCC

cccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccc


c	call  DGEFA(a,lda,n,ipvt,INFO)	
c	print *,info


	call DGECO(b,lmn,lmn,IPm,RCOND,r2)

c	print *,'rcond=',rcond

	call dgesl(b,lmn,lmn,ipm,r3,job)

	do i=1,lmn
	v(i) = r3(i)
	end do

	call dgesl(b,lmn,lmn,ipm,f,job)

	do i=1,lmn
	v1(i) = f(i)
	end do


ccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccc


CCC
C------------------------------------ calculation mu,V -------
CCC
      CALL CALCMU(N,LM,LMN,h,v,v1,FI,R1,SMU,gnorm)
CCC
      do 65 i=1,LMN
  65  v(I)=-v1(i)+smu*v(i)
C
C------------------------------------- calculation of tau -----
C
      IF(NTAU.EQ.1)TAU=TAU0

      IF(NTAU.EQ.2) then
      IF(D1.LT.D0)TAU=MIN(1.d0,2.d0*TP)
      IF(D1.GE.D0)TAU=MAX(TAU0,TP/2.d0)
	end if

      IF(NTAU.EQ.3) then
      IF(D1.LT.D0)TAU=MIN(1.d0,TP*(D0/D1))
      IF(D1.GE.D0)TAU=MAX(TAU0,TP*(D0/D1))
	end if

      IF(NTAU.EQ.4) then
	
      DO  L=1,LM
      L1n=(L-1)*n
      DO  I=1,N
      fi2(L,I)=fi(L,I)+v(L1N+I)
	end do
	end do
c      CALL NORM(N,LM,h,R1,fi2,gnorm)
      ev1=ev+smu
	dd1 = 0.d0
      CALL CALCF(LM,N,LMN,h,X,F,r1,fi2,ev1)
      DO  I=1,LMN
      IF(ABS(F(I)).gt.Dd1) dd1=AbS(F(I))
	end do
 
      TAU=MAX(TAU0,D1**2/(Dd1**2+D1**2))
	end if

      if(ntau.eq.5)then
	
	do tau1=tau0,1.d0,ht5 

	DO  L=1,LM
      L1n=(L-1)*n
      DO  I=1,N
      fi2(L,I)=fi(L,I)+tau1*v(L1N+I)
	end do
	end do
c      CALL NORM(N,LM,h,R1,fi2,gnorm)
      ev1=ev+tau1*smu
	dd1 = 0.d0
      CALL CALCF(LM,N,LMN,h,X,F,r1,fi2,ev1)
      DO  I=1,LMN
      IF(ABS(F(I)).gT.Dd1) dd1=AbS(F(I))
	end do

	if(tau1.eq.tau0) then
	eps1 = dd1
	tau = tau0
	else
	if(dd1.le.eps1) then
	eps1 = dd1
	tau = tau1
	end if
	end if
	end do
	end if

      print *,'************** tau=',tau,' *****************'
 
ccc
C************************************************************
C************************************************************
ccc
      D0=D1
      D1=0.d0
      TP=TAU   
      T=T+TAU
      NIT=NIT+1
C
C------------------------------------- new values of fi,B,ev ---
C
      DO 3 L=1,LM
      L1n=(L-1)*n
      DO 3 I=1,N
      fi(L,I)=fi(L,I)+TAU*v(L1N+I)
   3  CONTINUE

C
C-------------------------------------- NORMALIZATION ----------
C
      CALL NORM(N,LM,h,R1,FI,gnorm)

c
      ev=ev+smu*tau      
      GO TO 421
c------

  100 PRINT *,'THE END (DELTA<EPS)'

      call norm(n,lm,h,R1,fi,gnorm)

      GO TO 300

  200 PRINT *,'THE END (NIT>NMAX)'
  300 CONTINUE

      print *,' REZULTS:'
      PRINT *, ' ^^^^^^ I, X, FI1, fi2 ^^^^^^'
      do 42 i=1,n,nd5
  42  print 1000,i,X(I),fi(1,i),fi(2,i)
 221  CONTINUE
ccc

 1000 format(3x,i5,3(2x,e13.7))
 2000 format(5f15.5)
 3000 format(3f15.5)
      return
       END

C****************************************************************
C
      SUbROUTINE CALCF(LM,N,LMN,h,X,F,R1,fi,Ev)
      IMPLICIT REAL*8 (A-h,O-Z)
      DIMENSION X(N),F(LMN),fi(LM,n),R1(N)
CCC    
      DO 3 L=1,LM
      L1N=(L-1)*N
      do 1 i=1,n
      L1NI=L1N+I
      F(l1ni)=0.
      DO 4 K=1,LM
      do 2 j=1,n
      R1(J)=yyy(L,K,x(I),x(J))*FI(K,J)
   2  continue
      CALL SIMPSON(N,h,R1,SSS) 
      f(L1Ni)=F(l1ni)+(QQQ(L,K,x(i))-ev*RRR(L,K,X(I)))*fi(K,i)+sss 

   4  continue
   1  CONTINUE
   3  CONTINUE
      RETURN
      END
C
C******************************************************************
C
      SUbROUTINE CALCA(LM,N,LMN,X,A,R1,fi,TKSI,Ev)
      IMPLICIT REAL*8 (A-h,O-Z)
      DIMENSION X(N),A(LMN,LMN),fi(LM,n),R1(N),TKSI(N)
CCC    
      DO 4 L=1,LM
      L1N=(L-1)*N
      DO 4 K=1,LM
      K1N=(K-1)*N
      DO 4 I=1,N
      do 4 j=1,n
      SINT=yyy(L,K,x(I),x(J))*tksi(j)
      a(L1N+i,K1N+J)=(qqq(L,K,x(i))-Ev*RRR(L,K,X(I)))*AKRON(I,J)+SINT

  4   CONTINUE
      RETURN
      END
c*
c******************************************************************
c*
      function QQQ(L,K,x)
      implicit real*8 (a-h,o-z)
      QQQ=AKRON(L,K)
      return
      end
C*
c******************************************************************
c*
      function yyy(L,K,p,q)
      implicit real*8 (a-h,o-z)
      
      IF(L.EQ.1.AND.K.EQ.1)yyy=Q
      IF(L.EQ.1.AND.K.EQ.2)yyy=-1.d0
      IF(L.EQ.2.AND.K.EQ.1)yyy=P*P*P/Q
      IF(L.EQ.2.AND.K.EQ.2)yyy=-P/Q/Q

      return
      END
C*
C******************************************************************
C*
      FUNCTION RRR(L,K,X)
      IMPLICIT REAL*8 (A-h,O-Z)
      RRR=AKRON(L,K)
      IF(L.EQ.2.AND.K.EQ.2)RRR=1.d0+X-1.d0/X
      RETURN
      END
c*
c***************************************************************
c*
      function AKRON(L,K)
      implicit real*8 (a-h,o-z)
      AKRON=0.d0
      IF(L.EQ.K)AKRON=1.d0
      return
      END
c*
C***************************************************************
C*
      subroutine simpson(n,h,f,s)
      implicit real*8 (a-h,o-z)
      dimension f(n)
      s=f(1)+4.*f(2)
      nm1=n-2
      do 1 i=3,nm1,2
 1    s=s+f(i)*2.+f(i+1)*4.
      s=(s+f(n))*h/3.
      returN
      END
c*
c***************************************************************
c*
      SUbROUTINE NORM(N,LM,h,R1,FI,gnorm)
      IMPLICIT REAL*8 (A-h,O-Z)
      DIMENSION X(N),R1(N),FI(LM,N)

      DO 454 I=1,N
	r1(i) = 0.d0
      DO 454 L=1,LM
      R1(I)=fi(l,i)*fi(l,i)+r1(i)
  454 CONTINUE

      call simpson(n,h,R1,snorm)

      print *,'    norma=',snorm
      
      snorm=sqrt(snorm/gnorm)
      DO 666 L=1,LM
      do 556 i=1,n
  556 fi(L,i)=fi(L,i)/snorm

  666 CONTINUE
      RETURN
      END
C*
C************************************************************
C* 
      SUbROUTINE CALCMU(N,LM,LMN,h,v,v1,FI,R1,SMU,gnorm)
      IMPLICIT REAL*8 (A-h,O-Z)
      DIMENSION X(N),v(LMN),v1(LMN),FI(Lm,N),r1(n)   
CCC
      do 711 i=1,n
      R1(I)=0.d0
      DO 711 L=1,LM
      R1(I)=FI(L,I)*FI(L,I)+r1(i)
  711 CONTINUE
      CALL SIMPSON(N,h,R1,S)
CCC
CCC
      DO 713 i=1,N
	r1(i) = 0.d0
      DO 713 L=1,LM
      L1N=(L-1)*N
      R1(I)=v1(I+L1N)*fi(L,I)+r1(i)
  712 CONTINUE
      CALL SIMPSON(N,h,R1,s1)
  713 CONTINUE

CCC 

      do 72 i=1,n
	r1(i) = 0.d0
      DO 722 L=1,LM
      L1N=(L-1)*N
  722 R1(i)=R1(I)+v(L1N+I)*FI(L,I)
      call simpson(n,h,R1,s2)
  72  CONTINUE
c
CCC
      smu=(gnorm-s+2.d0*s1)/s2/2.d0
      
	print *,'S1,S2,SMU=',gnorm-s,s1,s2,smu
ccc
      return
      end

c*
c***************************************************************
c*

      SUbROUTINE KSI(N,h,TKSI)
      IMPLICIT REAL*8 (A-h,O-Z)
      DIMENSION TKSI(N)
CCC
c
C-------------------------------- SIMPSON --------
C
      NM1=N-1
      h3=h/3.d0
      h23=2.d0*h3
      h43=4.d0*h3
      TKSI(1)=h3
      DO 1 I=2,NM1,2
      TKSI(I)=h43
      TKSI(I+1)=h23
   1  CONTINUE
      TKSI(N)=h3
CCC
      RETURN
      END

c 
c*****************************************************
c*****************************************************
c*****************************************************
c

      SUBROUTINE DGESL(A,LDA,N,IPVT,B,JOB)
      INTEGER LDA,N,IPVT(1),JOB
      DOUBLE PRECISION A(LDA,1),B(1)
C
C     DGESL SOLVES THE DOUBLE PRECISION SYSTEM
C     A * X = B  OR  TRANS(A) * X = B
C     USING THE FACTORS COMPUTED BY DGECO OR DGEFA.
C
C     ON ENTRY
C
C	 A	 DOUBLE PRECISION(LDA, N)
C		 THE OUTPUT FROM DGECO OR DGEFA.
C
C	 LDA	 INTEGER
C		 THE LEADING DIMENSION OF THE ARRAY  A .
C
C	 N	 INTEGER
C		 THE ORDER OF THE MATRIX  A .
C
C	 IPVT	 INTEGER(N)
C		 THE PIVOT VECTOR FROM DGECO OR DGEFA.
C
C	 B	 DOUBLE PRECISION(N)
C		 THE RIGHT HAND SIDE VECTOR.
C
C	 JOB	 INTEGER
C		 = 0	     TO SOLVE  A*X = B ,
C		 = NONZERO   TO SOLVE  TRANS(A)*X = B  WHERE
C			     TRANS(A)  IS THE TRANSPOSE.
C
C     ON RETURN
C
C	 B	 THE SOLUTION VECTOR  X .
C
C     ERROR CONDITION
C
C	 A DIVISION BY ZERO WILL OCCUR IF THE INPUT FACTOR CONTAINS A
C	 ZERO ON THE DIAGONAL.	TECHNICALLY THIS INDICATES SINGULARITY
C	 BUT IT IS OFTEN CAUSED BY IMPROPER ARGUMENTS OR IMPROPER
C	 SETTING OF LDA .  IT WILL NOT OCCUR IF THE SUBROUTINES ARE
C	 CALLED CORRECTLY AND IF DGECO HAS SET RCOND .GT. 0.0
C	 OR DGEFA HAS SET INFO .EQ. 0 .
C
C     TO COMPUTE  INVERSE(A) * C  WHERE  C  IS A MATRIX
C     WITH  P  COLUMNS
C	    CALL DGECO(A,LDA,N,IPVT,RCOND,Z)
C	    IF (RCOND IS TOO SMALL) GO TO ...
C	    DO 10 J = 1, P
C	       CALL DGESL(A,LDA,N,IPVT,C(1,J),0)
C	 10 CONTINUE
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS DAXPY,DDOT
C
C     INTERNAL VARIABLES
C
      DOUBLE PRECISION DDOT,T
      INTEGER K,KB,L,NM1
C
      NM1 = N - 1
      IF (JOB .NE. 0) GO TO 50
C
C	 JOB = 0 , SOLVE  A * X = B
C	 FIRST SOLVE  L*Y = B
C
	 IF (NM1 .LT. 1) GO TO 30
	 DO 20 K = 1, NM1
	    L = IPVT(K)
	    T = B(L)
	    IF (L .EQ. K) GO TO 10
	       B(L) = B(K)
	       B(K) = T
   10	    CONTINUE
	    CALL DAXPY(N-K,T,A(K+1,K),1,B(K+1),1)
   20	 CONTINUE
   30	 CONTINUE
C
C	 NOW SOLVE  U*X = Y
C
	 DO 40 KB = 1, N
	    K = N + 1 - KB
	    B(K) = B(K)/A(K,K)
	    T = -B(K)
	    CALL DAXPY(K-1,T,A(1,K),1,B(1),1)
   40	 CONTINUE
      GO TO 100
   50 CONTINUE
C
C	 JOB = NONZERO, SOLVE  TRANS(A) * X = B
C	 FIRST SOLVE  TRANS(U)*Y = B
C
	 DO 60 K = 1, N
	    T = DDOT(K-1,A(1,K),1,B(1),1)
	    B(K) = (B(K) - T)/A(K,K)
   60	 CONTINUE
C
C	 NOW SOLVE TRANS(L)*X = Y
C
	 IF (NM1 .LT. 1) GO TO 90
	 DO 80 KB = 1, NM1
	    K = N - KB
	    B(K) = B(K) + DDOT(N-K,A(K+1,K),1,B(K+1),1)
	    L = IPVT(K)
	    IF (L .EQ. K) GO TO 70
	       T = B(L)
	       B(L) = B(K)
	       B(K) = T
   70	    CONTINUE
   80	 CONTINUE
   90	 CONTINUE
  100 CONTINUE
      RETURN
      END
c
c*********************************************************
c
      SUBROUTINE DGEFA(A,LDA,N,IPVT,INFO)
      INTEGER LDA,N,IPVT(1),INFO
      DOUBLE PRECISION A(LDA,1)
C
C     DGEFA FACTORS A DOUBLE PRECISION MATRIX BY GAUSSIAN ELIMINATION.
C
C     DGEFA IS USUALLY CALLED BY DGECO, BUT IT CAN BE CALLED
C     DIRECTLY WITH A SAVING IN TIME IF  RCOND	IS NOT NEEDED.
C     (TIME FOR DGECO) = (1 + 9/N)*(TIME FOR DGEFA) .
C
C     ON ENTRY
C
C	 A	 DOUBLE PRECISION(LDA, N)
C		 THE MATRIX TO BE FACTORED.
C
C	 LDA	 INTEGER
C		 THE LEADING DIMENSION OF THE ARRAY  A .
C
C	 N	 INTEGER
C		 THE ORDER OF THE MATRIX  A .
C
C     ON RETURN
C
C	 A	 AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS
C		 WHICH WERE USED TO OBTAIN IT.
C		 THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE
C		 L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER
C		 TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.
C
C	 IPVT	 INTEGER(N)
C		 AN INTEGER VECTOR OF PIVOT INDICES.
C
C	 INFO	 INTEGER
C		 = 0  NORMAL VALUE.
C		 = K  IF  U(K,K) .EQ. 0.0 .  THIS IS NOT AN ERROR
C		      CONDITION FOR THIS SUBROUTINE, BUT IT DOES
C		      INDICATE THAT DGESL OR DGEDI WILL DIVIDE BY ZERO
C		      IF CALLED.  USE  RCOND  IN DGECO FOR A RELIABLE
C		      INDICATION OF SINGULARITY.
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     BLAS DAXPY,DSCAL,IDAMAX
C
C     INTERNAL VARIABLES
C
      DOUBLE PRECISION T
      INTEGER IDAMAX,J,K,KP1,L,NM1
C
C
C     GAUSSIAN ELIMINATION WITH PARTIAL PIVOTING
C
      INFO = 0
      NM1 = N - 1
      IF (NM1 .LT. 1) GO TO 70
      DO 60 K = 1, NM1
	 KP1 = K + 1
C
C	 FIND L = PIVOT INDEX
C
	 L = IDAMAX(N-K+1,A(K,K),1) + K - 1
	 IPVT(K) = L
C
C	 ZERO PIVOT IMPLIES THIS COLUMN ALREADY TRIANGULARIZED
C
	 IF (A(L,K) .EQ. 0.0D0) GO TO 40
C
C	    INTERCHANGE IF NECESSARY
C
	    IF (L .EQ. K) GO TO 10
	       T = A(L,K)
	       A(L,K) = A(K,K)
	       A(K,K) = T
   10	    CONTINUE
C
C	    COMPUTE MULTIPLIERS
C
	    T = -1.0D0/A(K,K)
	    CALL DSCAL(N-K,T,A(K+1,K),1)
C
C	    ROW ELIMINATION WITH COLUMN INDEXING
C
	    DO 30 J = KP1, N
	       T = A(L,J)
	       IF (L .EQ. K) GO TO 20
		  A(L,J) = A(K,J)
		  A(K,J) = T
   20	       CONTINUE
	       CALL DAXPY(N-K,T,A(K+1,K),1,A(K+1,J),1)
   30	    CONTINUE
	 GO TO 50
   40	 CONTINUE
	    INFO = K
   50	 CONTINUE
   60 CONTINUE
   70 CONTINUE
      IPVT(N) = N
      IF (A(N,N) .EQ. 0.0D0) INFO = N
      RETURN
      END
*
c*****************************************************************
c*
      SUBROUTINE DAXPY(N,DA,DX,INCX,DY,INCY)
C
C     CONSTANT TIMES A VECTOR PLUS A VECTOR.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DY(1),DA
      INTEGER I,INCX,INCY,M,MP1,N
C
      IF(N.LE.0)RETURN
      IF (DA .EQ. 0.0D0) RETURN
      IF(INCx.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C	 CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C	   NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
	DY(IY) = DY(IY) + DA*DX(IX)
	IX = IX + INCX
	IY = IY + INCY
   10 CONTINUE
      RETURN
C
C	 CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C	 CLEAN-UP LOOP
C
   20 M = MOD(N,4)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
	DY(I) = DY(I) + DA*DX(I)
   30 CONTINUE
      IF( N .LT. 4 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,4
	DY(I) = DY(I) + DA*DX(I)
	DY(I + 1) = DY(I + 1) + DA*DX(I + 1)
	DY(I + 2) = DY(I + 2) + DA*DX(I + 2)
	DY(I + 3) = DY(I + 3) + DA*DX(I + 3)
   50 CONTINUE
      RETURN
      END
c
c****************************************************************
c
      DOUBLE PRECISION FUNCTION DDOT(N,DX,INCX,DY,INCY)
C
C     FORMS THE DOT PRODUCT OF TWO VECTORS.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DY(1),DTEMP
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
      DDOT = 0.0D0
      DTEMP = 0.0D0
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C	 CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS
C	   NOT EQUAL TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
	DTEMP = DTEMP + DX(IX)*DY(IY)
	IX = IX + INCX
	IY = IY + INCY
   10 CONTINUE
      DDOT = DTEMP
      RETURN
C
C	 CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C	 CLEAN-UP LOOP
C
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
	DTEMP = DTEMP + DX(I)*DY(I)
   30 CONTINUE
      IF( N .LT. 5 ) GO TO 60
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
	DTEMP = DTEMP + DX(I)*DY(I) + DX(I + 1)*DY(I + 1) +
     *	 DX(I + 2)*DY(I + 2) + DX(I + 3)*DY(I + 3) + DX(I + 4)*DY(I + 4)
   50 CONTINUE
   60 DDOT = DTEMP
      RETURN
      END
c
c*************************************************************
c*
      SUBROUTINE  DSCAL(N,DA,DX,INCX)
C
C     SCALES A VECTOR BY A CONSTANT.
C     USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DA,DX(1)
      INTEGER I,INCX,M,MP1,N,NINCX
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C	 CODE FOR INCREMENT NOT EQUAL TO 1
C
      NINCX = N*INCX
      DO 10 I = 1,NINCX,INCX
	DX(I) = DA*DX(I)
   10 CONTINUE
      RETURN
C
C	 CODE FOR INCREMENT EQUAL TO 1
C
C
C	 CLEAN-UP LOOP
C
   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
	DX(I) = DA*DX(I)
   30 CONTINUE
      IF( N .LT. 5 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,5
	DX(I) = DA*DX(I)
	DX(I + 1) = DA*DX(I + 1)
	DX(I + 2) = DA*DX(I + 2)
	DX(I + 3) = DA*DX(I + 3)
	DX(I + 4) = DA*DX(I + 4)
   50 CONTINUE
      RETURN
      END
c
c****************************************************************
c
      INTEGER FUNCTION IDAMAX(N,DX,INCX)
C
C     FINDS THE INDEX OF ELEMENT HAVING MAX. ABSOLUTE VALUE.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DMAX
      INTEGER I,INCX,IX,N
C
      IDAMAX = 0
      IF( N .LT. 1 ) RETURN
      IDAMAX = 1
      IF(N.EQ.1)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C	 CODE FOR INCREMENT NOT EQUAL TO 1
C
      IX = 1
      DMAX = DABS(DX(1))
      IX = IX + INCX
      DO 10 I = 2,N
	 IF(DABS(DX(IX)).LE.DMAX) GO TO 5
	 IDAMAX = I
	 DMAX = DABS(DX(IX))
    5	 IX = IX + INCX
   10 CONTINUE
      RETURN
C
C	 CODE FOR INCREMENT EQUAL TO 1
C
   20 DMAX = DABS(DX(1))
      DO 30 I = 2,N
	 IF(DABS(DX(I)).LE.DMAX) GO TO 30
	 IDAMAX = I
	 DMAX = DABS(DX(I))
   30 CONTINUE
      RETURN
      END
c
c*******************************************************************
c

      SUBROUTINE DGECO(A,LDA,N,IPVT,RCOND,Z)
      INTEGER LDA,N,IPVT(1)
      DOUBLE PRECISION A(LDA,1),Z(1)
      DOUBLE PRECISION RCOND
C
C     DGECO FACTORS A DOUBLE PRECISION MATRIX BY GAUSSIAN ELIMINATION
C     AND ESTIMATES THE CONDITION OF THE MATRIX.
C
C     IF  RCOND  IS NOT NEEDED, DGEFA IS SLIGHTLY FASTER.
C     TO SOLVE	A*X = B , FOLLOW DGECO BY DGESL.
C     TO COMPUTE  INVERSE(A)*C , FOLLOW DGECO BY DGESL.
C     TO COMPUTE  DETERMINANT(A) , FOLLOW DGECO BY DGEDI.
C     TO COMPUTE  INVERSE(A) , FOLLOW DGECO BY DGEDI.
C
C     ON ENTRY
C
C	 A	 DOUBLE PRECISION(LDA, N)
C		 THE MATRIX TO BE FACTORED.
C
C	 LDA	 INTEGER
C		 THE LEADING DIMENSION OF THE ARRAY  A .
C
C	 N	 INTEGER
C		 THE ORDER OF THE MATRIX  A .
C
C     ON RETURN
C
C	 A	 AN UPPER TRIANGULAR MATRIX AND THE MULTIPLIERS
C		 WHICH WERE USED TO OBTAIN IT.
C		 THE FACTORIZATION CAN BE WRITTEN  A = L*U  WHERE
C		 L  IS A PRODUCT OF PERMUTATION AND UNIT LOWER
C		 TRIANGULAR MATRICES AND  U  IS UPPER TRIANGULAR.
C
C	 IPVT	 INTEGER(N)
C		 AN INTEGER VECTOR OF PIVOT INDICES.
C
C	 RCOND	 DOUBLE PRECISION
C		 AN ESTIMATE OF THE RECIPROCAL CONDITION OF  A .
C		 FOR THE SYSTEM  A*X = B , RELATIVE PERTURBATIONS
C		 IN  A	AND  B	OF SIZE  EPSILON  MAY CAUSE
C		 RELATIVE PERTURBATIONS IN  X  OF SIZE	EPSILON/RCOND .
C		 IF  RCOND  IS SO SMALL THAT THE LOGICAL EXPRESSION
C			    1.0 + RCOND .EQ. 1.0
C		 IS TRUE, THEN	A  MAY BE SINGULAR TO WORKING
C		 PRECISION.  IN PARTICULAR,  RCOND  IS ZERO  IF
C		 EXACT SINGULARITY IS DETECTED OR THE ESTIMATE
C		 UNDERFLOWS.
C
C	 Z	 DOUBLE PRECISION(N)
C		 A WORK VECTOR WHOSE CONTENTS ARE USUALLY UNIMPORTANT.
C		 IF  A	IS CLOSE TO A SINGULAR MATRIX, THEN  Z	IS
C		 AN APPROXIMATE NULL VECTOR IN THE SENSE THAT
C		 NORM(A*Z) = RCOND*NORM(A)*NORM(Z) .
C
C     LINPACK. THIS VERSION DATED 08/14/78 .
C     CLEVE MOLER, UNIVERSITY OF NEW MEXICO, ARGONNE NATIONAL LAB.
C
C     SUBROUTINES AND FUNCTIONS
C
C     LINPACK DGEFA
C     BLAS DAXPY,DDOT,DSCAL,DASUM
C     FORTRAN DABS,DMAX1,DSIGN
C
C     INTERNAL VARIABLES
C
      DOUBLE PRECISION DDOT,EK,T,WK,WKM
      DOUBLE PRECISION ANORM,S,DASUM,SM,YNORM
      INTEGER INFO,J,K,KB,KP1,L
C
C
C     COMPUTE 1-NORM OF A
C
      ANORM = 0.0D0
      DO 10 J = 1, N
	 ANORM = DMAX1(ANORM,DASUM(N,A(1,J),1))
   10 CONTINUE
C
C     FACTOR
C
      CALL DGEFA(A,LDA,N,IPVT,INFO)
C
C     RCOND = 1/(NORM(A)*(ESTIMATE OF NORM(INVERSE(A)))) .
C     ESTIMATE = NORM(Z)/NORM(Y) WHERE	A*Z = Y  AND  TRANS(A)*Y = E .
C     TRANS(A)	IS THE TRANSPOSE OF A .  THE COMPONENTS OF  E  ARE
C     CHOSEN TO CAUSE MAXIMUM LOCAL GROWTH IN THE ELEMENTS OF W  WHERE
C     TRANS(U)*W = E .	THE VECTORS ARE FREQUENTLY RESCALED TO AVOID
C     OVERFLOW.
C
C     SOLVE TRANS(U)*W = E
C
      EK = 1.0D0
      DO 20 J = 1, N
	 Z(J) = 0.0D0
   20 CONTINUE
      DO 100 K = 1, N
	 IF (Z(K) .NE. 0.0D0) EK = DSIGN(EK,-Z(K))
	 IF (DABS(EK-Z(K)) .LE. DABS(A(K,K))) GO TO 30
	    S = DABS(A(K,K))/DABS(EK-Z(K))
	    CALL DSCAL(N,S,Z,1)
	    EK = S*EK
   30	 CONTINUE
	 WK = EK - Z(K)
	 WKM = -EK - Z(K)
	 S = DABS(WK)
	 SM = DABS(WKM)
	 IF (A(K,K) .EQ. 0.0D0) GO TO 40
	    WK = WK/A(K,K)
	    WKM = WKM/A(K,K)
	 GO TO 50
   40	 CONTINUE
	    WK = 1.0D0
	    WKM = 1.0D0
   50	 CONTINUE
	 KP1 = K + 1
	 IF (KP1 .GT. N) GO TO 90
	    DO 60 J = KP1, N
	       SM = SM + DABS(Z(J)+WKM*A(K,J))
	       Z(J) = Z(J) + WK*A(K,J)
	       S = S + DABS(Z(J))
   60	    CONTINUE
	    IF (S .GE. SM) GO TO 80
	       T = WKM - WK
	       WK = WKM
	       DO 70 J = KP1, N
		  Z(J) = Z(J) + T*A(K,J)
   70	       CONTINUE
   80	    CONTINUE
   90	 CONTINUE
	 Z(K) = WK
  100 CONTINUE
      S = 1.0D0/DASUM(N,Z,1)
      CALL DSCAL(N,S,Z,1)
C
C     SOLVE TRANS(L)*Y = W
C
      DO 120 KB = 1, N
	 K = N + 1 - KB
	 IF (K .LT. N) Z(K) = Z(K) + DDOT(N-K,A(K+1,K),1,Z(K+1),1)
	 IF (DABS(Z(K)) .LE. 1.0D0) GO TO 110
	    S = 1.0D0/DABS(Z(K))
	    CALL DSCAL(N,S,Z,1)
  110	 CONTINUE
	 L = IPVT(K)
	 T = Z(L)
	 Z(L) = Z(K)
	 Z(K) = T
  120 CONTINUE
      S = 1.0D0/DASUM(N,Z,1)
      CALL DSCAL(N,S,Z,1)
C
      YNORM = 1.0D0
C
C     SOLVE L*V = Y
C
      DO 140 K = 1, N
	 L = IPVT(K)
	 T = Z(L)
	 Z(L) = Z(K)
	 Z(K) = T
	 IF (K .LT. N) CALL DAXPY(N-K,T,A(K+1,K),1,Z(K+1),1)
	 IF (DABS(Z(K)) .LE. 1.0D0) GO TO 130
	    S = 1.0D0/DABS(Z(K))
	    CALL DSCAL(N,S,Z,1)
	    YNORM = S*YNORM
  130	 CONTINUE
  140 CONTINUE
      S = 1.0D0/DASUM(N,Z,1)
      CALL DSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
C     SOLVE  U*Z = V
C
      DO 160 KB = 1, N
	 K = N + 1 - KB
	 IF (DABS(Z(K)) .LE. DABS(A(K,K))) GO TO 150
	    S = DABS(A(K,K))/DABS(Z(K))
	    CALL DSCAL(N,S,Z,1)
	    YNORM = S*YNORM
  150	 CONTINUE
	 IF (A(K,K) .NE. 0.0D0) Z(K) = Z(K)/A(K,K)
	 IF (A(K,K) .EQ. 0.0D0) Z(K) = 1.0D0
	 T = -Z(K)
	 CALL DAXPY(K-1,T,A(1,K),1,Z(1),1)
  160 CONTINUE
C     MAKE ZNORM = 1.0
      S = 1.0D0/DASUM(N,Z,1)
      CALL DSCAL(N,S,Z,1)
      YNORM = S*YNORM
C
      IF (ANORM .NE. 0.0D0) RCOND = YNORM/ANORM
      IF (ANORM .EQ. 0.0D0) RCOND = 0.0D0
      RETURN
      END


      DOUBLE PRECISION FUNCTION DASUM(N,DX,INCX)
C
C     TAKES THE SUM OF THE ABSOLUTE VALUES.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
      DOUBLE PRECISION DX(1),DTEMP
      INTEGER I,INCX,M,MP1,N,NINCX
C
      DASUM = 0.0D0
      DTEMP = 0.0D0
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1)GO TO 20
C
C	 CODE FOR INCREMENT NOT EQUAL TO 1
C
      NINCX = N*INCX
      DO 10 I = 1,NINCX,INCX
	DTEMP = DTEMP + DABS(DX(I))
   10 CONTINUE
      DASUM = DTEMP
      RETURN
C
C	 CODE FOR INCREMENT EQUAL TO 1
C
C
C	 CLEAN-UP LOOP
C
   20 M = MOD(N,6)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
	DTEMP = DTEMP + DABS(DX(I))
   30 CONTINUE
      IF( N .LT. 6 ) GO TO 60
   40 MP1 = M + 1
      DO 50 I = MP1,N,6
	DTEMP = DTEMP + DABS(DX(I)) + DABS(DX(I + 1)) + DABS(DX(I + 2))
     *	+ DABS(DX(I + 3)) + DABS(DX(I + 4)) + DABS(DX(I + 5))
   50 CONTINUE
   60 DASUM = DTEMP
      RETURN
      END

